#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>
#include "arduino.h"
#include "request.h"
#include "uss.h"
#include "io.h"

int main() {
	int mode,speed, dist;
	double volt;
	//char buf[256];
	run_state_t state;
	long uss_l, uss_r;
	int flag_l = 0, flag_r = 0;
	int sw_f, sw_l, sw_r;
	srand((unsigned int)time(NULL));
	int angle_of_rotation;
	int direction_of_rotation;

	if (arduino_open() != 0) return -1;
	if (io_open() != 0) return -1;
	if (uss_open_l() != 0) {
		printf(" left uss open faild !!\n");
		flag_l = -1;
	}
	if (uss_open_r() != 0) {
		printf(" right uss open faild !!\n");
		flag_r = -1;
	}
	if (flag_l == -1 && flag_r == -1) return -1;

	mode = 0;

	while (1) {
		/*printf("0:straight 30cm 1:straight 60cm 2:quit\n");
		scanf("%d", &mode);*/

		switch (mode) {
		case 0:
			request_set_runmode(STR, 30, 300);
			while (1) {
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) break;
				uss_l = uss_get_l();
				usleep(500 * 1000);
				uss_r = uss_get_r();
				usleep(500 * 1000);
				printf("uss_l = %6ld, uss_r = %6ld\n", uss_l, uss_r);
				if (uss_l <= 50 || uss_r <= 50) {
					request_set_runmode(STP, 0, 0);
					mode = 1;
					break;
				}
				io_get_sw(&sw_f, &sw_l, &sw_r);
				printf("sw_f = %d\n", sw_f);
				if (sw_f == 0) {
					request_set_runmode(STP, 0, 0);
					mode = 1;
					break;
				}
			}

			break;
		case 1:
			request_set_runmode(STR, 60, 300);
			while (1) {
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) break;
			}
			break;
		case 2:
			return 0;
		default:
			break;
			
		}
	}


	arduino_close();
	return 0;
}