#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>

#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>


#include "arduino.h"
#include "request.h"
#include "uss.h"
#include "io.h"

#define limit_number_of_balls 1
#define cargo_Length 60
extern int com_recv_set();
extern int com_recv_get();


int main() {
	int mode,speed, dist;
	int face_mode;
	double volt;
	//char buf[256];
	run_state_t state;
	long uss_l, uss_r, uss_b, uss_b2;
	int flag_l = 0, flag_r, flag_b, flag_b2 = 0;
	int sw_f, sw_l, sw_r;
	int number_of_balls = 0;
	int i = 0;
	srand((unsigned int)time(NULL));
	//int angle_of_rotation;
	//int direction_of_rotation;

	if (arduino_open() != 0) return -1;
	if (io_open() != 0) return -1;
	if (uss_open_l() != 0) {
		printf(" left uss open faild !!\n");
		flag_l = -1;
	}
	if (uss_open_r() != 0) {
		printf(" right uss open faild !!\n");
		flag_r = -1;
	}
	if (uss_open_b() != 0) {
		printf(" back uss open faild !!\n");
		flag_b = -1;
	}
	if (uss_open_b2() != 0) {
		printf(" back2 uss open faild !!\n");
		flag_b2 = -1;
	}
	if (flag_l == -1 && flag_r == -1 && flag_b == -1 && flag_b2 == -1) return -1;

	com_recv_set();
	mode = 0;

	while (1) {
		/*printf("0:straight 30cm 1:straight 60cm 2:quit\n");
		scanf("%d", &mode);*/

		switch (mode) {
		case 0://ボール探知モード
			printf("ボール探知モードです");
			request_set_runmode(ROT, 20, 360);
			while (1) {
				face_mode = com_recv_get();
				request_get_runmode(&state, &speed, &dist);
				request_get_batt(&volt);
				if (state == STP) break;

				if (face_mode == 49 || face_mode == 52) {
					request_set_runmode(STP, 0, 0);
					mode = 1;
					break;
				}
				//if (volt < 4) {
				//	request_set_runmode(STP, 0, 0);
				//	printf("emergency stoped \ngo to stop mode \n");
				//	mode = 3;
				//	break;
				//}

			}
			break;
		case 1://回収走行モード
			request_set_runmode(STR, 30, 300);
			while (1) {
				printf("ボールが見えなくなったら止まります\n");
				request_get_batt(&volt);
				/*if (volt < 4) {
					request_set_runmode(STP, 0, 0);
					printf("emergency stoped \ngo to stop mode \n");
					mode = 3;
					break;
				}*/
				face_mode = com_recv_get();
				if (face_mode == 50 || face_mode ==51) {
					printf("ボールが見えないので60cm走った後止まります");
					mode = 0;
					request_set_runmode(STR, 30, 60);
						while (1) {
							request_get_runmode(&state, &speed, &dist);
							if (state == STP) break;
							io_get_sw(&sw_f, &sw_l, &sw_r);
							printf("sw_f = %d\n", sw_f);
							if (sw_f == 0) {
								printf("ボールを回収しました");
								number_of_balls++;
								request_set_runmode(STP, 0, 0);
								if (number_of_balls == limit_number_of_balls) {
									printf("所持数限界です。カラーコーンモードに移行します。");
									mode = 4;
								}
								break;
							}
						}
					request_set_runmode(STP, 0, 0);
					break;

				}
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) break;
				uss_l = uss_get_l();
				usleep(100 * 1000);
				uss_r = uss_get_r();
				usleep(100 * 1000);
				printf("uss_l = %6ld, uss_r = %6ld\n", uss_l, uss_r);
				if ((uss_l != -1 && uss_l <= 65 )|| (uss_r != -1 && uss_r <= 65)) {
					request_set_runmode(STP, 0, 0);
					usleep(3 * 1000 * 1000);
					uss_l = uss_get_l();
					usleep(100 * 1000);
					uss_r = uss_get_r();
					usleep(100 * 1000);
					if ((uss_l != -1 && uss_l <= 65) || (uss_r != -1 && uss_r <= 65))
					{
						mode = 2;
						break;

					}
					else {
						mode = 1;
						break;
					}

				}
				io_get_sw(&sw_f, &sw_l, &sw_r);
				printf("sw_f = %d\n", sw_f);
				if (sw_f == 0) {
					mode = 0;
					request_set_runmode(STP, 0, 0);
					printf("ボールを回収しました");
					number_of_balls++;
					if (number_of_balls == limit_number_of_balls) {
						printf("所持数限界です。カラーコーンモードに移行します。");
						mode = 4;
						break;
					}
					break;
				}
			}

			break;
		case 2://回避行動モード
		request_set_runmode(STP, 0, 0);
		usleep(1500 * 1000);
		uss_l = uss_get_l();
		uss_r = uss_get_r();
		if ((uss_l != -1 && uss_l <= 65) || (uss_r != -1 && uss_r <= 65)) {
			printf("avoiding\n");
			while(1){
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) break;
			}
			request_set_runmode(ROT, 20, 90);//回転
			printf("turn1\n");

			while(1){
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) break;
			}
			request_set_runmode(STR, 20, -50);//後退
			while(1){
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) break;
			}

			request_set_runmode(ROT, 20, -90);//回転
			while(1){
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) break;
			}
			request_set_runmode(STR, 20, 30);//前進
			while(1){
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) break;
			}

			request_set_runmode(ROT, 20, 90);//回転
			while(1){
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) break;
			}
			printf("complete\n");
		}
		mode = 0;
		break;
			
		//case 3://緊急停止モード
		//	while (volt < 5)
		//	{
		//		request_get_batt(&volt);
		//	}
		//	printf("restart in 5[sec]\n");
		//	usleep(5 * 1000 * 1000);
		//	printf("restart\n");
		//	mode = 0;
		//	break;

		case 4://コーン探知モード
			printf("コーン探知モードです");
			request_set_runmode(ROT, 20, 360);
			while (1) {
				face_mode = com_recv_get();
				request_get_runmode(&state, &speed, &dist);
				request_get_batt(&volt);
				if (state == STP) break;

				if (face_mode == 51 || face_mode == 52) {
					request_set_runmode(STP, 0, 0);
					mode = 5;
					break;
				}
				/*if (volt < 4) {
					request_set_runmode(STP, 0, 0);
					printf("emergency stoped \ngo to stop mode \n");
					mode = 3;
					break;
				}*/

			}
			break;
		case 5://回収走行モード
			request_set_runmode(STR, 30, 300);
			while (1) {
				printf("コーンが見えなくなったら止まります\n");
				/*request_get_batt(&volt);
				if (volt < 4) {
					request_set_runmode(STP, 0, 0);
					printf("emergency stoped \ngo to stop mode \n");
					mode = 3;
					break;
				}*/
				face_mode = com_recv_get();
				if (face_mode == 49 || face_mode == 50) {
					printf("コーンが見えないので60cm走った後止まります\n");
					request_set_runmode(STR, 30, 60);
					while (1) {
						request_get_runmode(&state, &speed, &dist);
						if (state == STP) break;	
					}
					request_set_runmode(STP, 0, 0);
					mode = 6;//--------------------------------------------------------------------------------
					break;

				}
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) break;
				uss_l = uss_get_l();
				usleep(100 * 1000);
				uss_r = uss_get_r();
				usleep(100 * 1000);
				printf("uss_l = %6ld, uss_r = %6ld\n", uss_l, uss_r);
				if ((uss_l != -1 && uss_l <= 65) || (uss_r != -1 && uss_r <= 65)) {
					request_set_runmode(STP, 0, 0);
					usleep(3 * 1000 * 1000);
					uss_l = uss_get_l();
					usleep(100 * 1000);
					uss_r = uss_get_r();
					usleep(100 * 1000);
					if ((uss_l != -1 && uss_l <= 65) || (uss_r != -1 && uss_r <= 65))
					{
						mode = 2;
						break;

					}
					else {
						mode = 5;
						break;
					}

				}
			}

			break;
		//case 4://補正モード
		//	request_set_runmode(ROT, 30, -180);
		//	while (1) {
		//		request_get_runmode(&state, &speed, &dist);
		//		if (state == STP) break;
		//	}
		//	mode = 1;
		case 6://ボールが取られるまで待機モード
			printf("待機モードです\n");
			uss_b = uss_get_b();
			usleep(10 * 1000);
			uss_b2 = uss_get_b2();
			usleep(10 * 1000);
			printf("uss_b = %6ld,uss_b2 = %6ld\n", uss_b, uss_b2);
			while (uss_b <= cargo_Length || uss_b2 <= cargo_Length) {
				uss_b = uss_get_b();
				uss_b2 = uss_get_b2();
				usleep(100 * 1000);
				request_set_runmode(STP, 0, 0);
				printf("・");
				i++;
				if (i % 20 == 0) {
					printf("\x1b[20D \x1b[k");
				}

			}
			printf("ボールが取られました。\n");
			number_of_balls = 0;
			mode = 0;
			break;
		default:
			break;

		}
	}


	arduino_close();
	return 0;
}
