#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>

#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>


#include "arduino.h"
#include "request.h"
#include "uss.h"
#include "io.h"

extern int com_recv_set();
extern int com_recv_get();




int main() {
	int mode,speed, dist;
	int face_mode;
	//double volt;
	//char buf[256];
	run_state_t state;
	long uss_l, uss_r;
	int flag_l = 0, flag_r = 0;
	int sw_f, sw_l, sw_r;
	srand((unsigned int)time(NULL));
	int angle_of_rotation;
	int direction_of_rotation;

	if (arduino_open() != 0) return -1;
	if (io_open() != 0) return -1;
	if (uss_open_l() != 0) {
		printf(" left uss open faild !!\n");
		flag_l = -1;
	}
	if (uss_open_r() != 0) {
		printf(" right uss open faild !!\n");
		flag_r = -1;
	}
	if (flag_l == -1 && flag_r == -1) return -1;

	com_recv_set();
	mode = 0;

	while (1) {
		/*printf("0:straight 30cm 1:straight 60cm 2:quit\n");
		scanf("%d", &mode);*/

		switch (mode) {
		case 0:
			request_set_runmode(STR, 30, 300);
			while (1) {
				//if (state == STP) break;
				uss_l = uss_get_l();
				usleep(100 * 1000);
				uss_r = uss_get_r();
				usleep(100 * 1000);

				face_mode = com_recv_get();
				printf("%d", face_mode);
				if (face_mode == 49) {
					request_set_runmode(STR, 30, 300);
				}
				else if (face_mode == 50) {
					request_set_runmode(STP, 0, 0);
				}
				request_get_runmode(&state, &speed, &dist);

				//printf("uss_l = %6ld, uss_r = %6ld\n", uss_l, uss_r);
				//if (uss_l <= 65 || uss_r <= 65) {
				//	request_set_runmode(STP, 0, 0);
				//	mode = 1;
				//	break;
				//}
				//io_get_sw(&sw_f, &sw_l, &sw_r);
				//printf("sw_f = %d\n", sw_f);
				//if (sw_f == 0) {
				//	request_set_runmode(STP, 0, 0);
				//	mode = 1;
				//	break;
				//}

			}

			break;
		case 1:
			usleep(1 * 1000 * 1000);
			angle_of_rotation = 90 + (int)(rand() * (180 - 90 + 1.0) / (1.0 + RAND_MAX));
			direction_of_rotation = rand() % 2 + 1;
			if (direction_of_rotation == 1)
			{
				angle_of_rotation *= (-1);
			}
			else {
				angle_of_rotation *= 1;
			}
			dist = angle_of_rotation;
			mode = 2;
			break;
		case 2:
			request_set_runmode(ROT, 30, dist);
			while (1) {
				request_get_runmode(&state, &speed, &dist);
				if (state == STP) {
					mode = 0;
					break;
				}
			}
			mode = 0;

		default:
			break;
			
		}
	}


	arduino_close();
	return 0;
}